
/* 
 * Copyright (c) 2011 Ed Halley <ed@halley.cc>
 * Offered under the MIT License.
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */

package cc.halley.kata;

import java.util.Collection;

/**
 * String utilities Java forgot.
 * 
 * @author halley - Ed Halley
 */
public class S
{
	public static String plural(int n, String singular, String plural)
		{ return (n == 1)? singular : plural; }

	public static String join(String sep, Object[] array)
    {
		StringBuilder sb = new StringBuilder();
		String p = null;
		for (Object each : array)
		{
			if (p != null) sb.append(p); p = sep;
			sb.append((each == null)?  "(null)"  :  each.toString());
		}
		return sb.toString();
    }

	public static String join(String sep, Collection<?> collection)
		{ return join(sep, collection.toArray()); }

	public static String join(char sep, Collection<?> collection)
		{ return join(String.valueOf(sep), collection.toArray()); }

	public static String join(char sep, Object[] array)
		{ return join(String.valueOf(sep), array); }

	public static String join(String[] bits)
		{ return join(null, bits); }
}
